// Vehicle speed limiter by Faguss (ofp-faguss.com) 16.09.2022

if (isNil "FGS_VEH_SPEED_LIMITER") then {
FGS_VEH_SPEED_LIMITER        = true;
FGS_VEH_SPEED_LIMITER_DIALOG = 0;
FGS_VEH_SPEED_LIMITER_ENTER  = false;

_nul = _this spawn {
	_version       = 1.01;
	_menu          = displayNull;
	_cycle_select  = 0;
	_factor        = 0;
	_max_speed     = 0;
	_last_vehicle  = player;
	_pressed       = [];
	_action_types  = [
		"nothing",	//0
		"Select value from the list",	//1
		"Confirm selection",	//2
		"Select value from the list and enable",	//3
		"Modify the current limit",	//4
		"Set limiter to this value",	//5
		"Open this menu"	//6
	];
	_menu_order = [0, 6, 5, 4, 3, 1, 2];
	_default_config = [_version, [
		[1, 6],
		[2, 1, -1, [50,100,150,200,250]],
		[3, 1, +1, [50,100,150,200,250]],
		[4, 2],

		[5, 3, -1, [50,100,150,200,250]],
		[6, 3, +1, [50,100,150,200,250]],

		[7, 4, -5],
		[8, 4, +5],

		[9, 5, 128]
	], "50"];
	
	// Create a hotkey for ENTER key
	waitUntil {!(isNull (findDisplay 46))};
	(findDisplay 46) displayAddEventHandler ["KeyDown", {if ((_this select 1) in [28,156]) then {FGS_VEH_SPEED_LIMITER_ENTER=true}}];
	
	// Load settings
	_config = profileNamespace getVariable "fgs_veh_speed_limiter";
	if (isNil "_config") then {
		_config =+ _default_config;
		profileNamespace setVariable ["fgs_veh_speed_limiter", _config]
	} else {
		if (count _config != 3 || typename (_config select 0) != "SCALAR") then {
			_config =+ _default_config;
			profileNamespace setVariable ["fgs_veh_speed_limiter", _config]			
		}
	};
	
	_controls = _config select 1;
	
	// Prepare HUD
	_hud_layer = ("FGS_VEH_SPEED_LIMITER_LAYER" call BIS_fnc_rscLayer);
	_hud_layer cutRsc ["FGS_veh_speed_limiter_hud","PLAIN"];
	waitUntil {!isNull (uiNameSpace getVariable "FGS_VEH_SPEED_LIMITER_HUD")};
	_hud_var = uiNameSpace getVariable "FGS_VEH_SPEED_LIMITER_HUD";
	_hud_text = _hud_var displayCtrl 1001;
	_hud_text ctrlSetBackgroundColor [0,0,0,0];
	
	// Function for changing HUD
	_fgs_veh_speed_limiter_set_text = {
		private ["_hud_text", "_string", "_color", "_width"];
		_hud_text = _this select 0;
		_string   = _this select 1;
		_color    = _this select 2;
		
		_hud_text ctrlShow true;
		_hud_text ctrlSetStructuredText parseText _string;
		_hud_text ctrlSetBackgroundColor _color;
		
		if (count _string > 0) then {
			_width = ctrlTextWidth _hud_text;
			_width = _width + (_width/count _string)*0.5;
			_hud_text ctrlSetPosition [safeZoneX + safeZoneW - _width, safeZoneY + safeZoneH - 0.1, _width, 0.1];
			_hud_text ctrlCommit 0;
		};
	};
	
	// Main loop
	while {true} do {
		_v = vehicle player;
		
		// Wait for the player to be in the vehicle
		if (_v != player && canMove _v && driver _v == player) then {
			_new_max_speed = _max_speed;
			
			// Open menu
			if (FGS_VEH_SPEED_LIMITER_DIALOG == 1) then {
				FGS_VEH_SPEED_LIMITER_DIALOG = 0;
				
				if (!dialog) then {
					createDialog "FGS_veh_speed_limiter_dialog";
					FGS_VEH_SPEED_LIMITER_ENTER = false;					
					
					_i = -1;
					while {_i=_i+1; _i<20} do {
						ctrlSetText [1000+_i*10, Format["User%1",_i+1]];
						{_index=lbAdd [1001+_i*10,_action_types select _x]; lbSetValue [1001+_i*10, _index, _x]} forEach _menu_order;
						lbSetCurSel [1001+_i*10, 0];
						ctrlShow [1002+_i*10, false];
						ctrlSetText [1002+_i*10, "1"];
						ctrlShow [1003+_i*10, false];
						ctrlSetText [1003+_i*10, "50,100,150,200,250"];
					};
					
					{
						// Show drop-down
						lbSetCurSel [1001+((_x select 0)-1)*10, _menu_order find (_x select 1)];
						
						// Show first input
						if ((_x select 1) in [1,3,4,5]) then {
							ctrlShow [1002+((_x select 0)-1)*10, true];
							ctrlSetText [1002+((_x select 0)-1)*10, Format["%1",_x select 2]];
						};
						
						// Show second input
						if ((_x select 1) in [1,3]) then {
							_array = toArray Format ["%1",(_x select 3)-[0]];
							_array = _array - [91,93];
							
							ctrlShow [1003+((_x select 0)-1)*10, true];
							ctrlSetText [1003+((_x select 0)-1)*10, toString _array];
						};
					} forEach _controls;
					
					ctrlSetText [503, _config select 2];
					waitUntil {_menu=findDisplay 8347837; !(isNull _menu)};
					ctrlSetFocus (_menu displayCtrl 502);
					(_menu displayCtrl 1665004) ctrlSetTooltip Format ["Version: %1", _version];
				};
			};
			
			// Show and hide dialog elements
			if (dialog && ctrlVisible 1665003) then {
				_i = -1;
				while {_i=_i+1; _i<20} do {
					ctrlShow [1002+_i*10, (lbValue [(1001+_i*10), lbCurSel (1001+_i*10)]) in [1,3,4,5]];
					ctrlShow [1003+_i*10, (lbValue [(1001+_i*10), lbCurSel (1001+_i*10)]) in [1,3]];
				};
				
				// Pressing enter on the input field closes the menu
				if (FGS_VEH_SPEED_LIMITER_ENTER && focusedCtrl _menu == (_menu displayCtrl 502)) then {
					FGS_VEH_SPEED_LIMITER_ENTER  = false;
					FGS_VEH_SPEED_LIMITER_DIALOG = 3;
				};
				
				// Save data and exit menu
				if (FGS_VEH_SPEED_LIMITER_DIALOG == 2) then {
					_controls resize 0;
					_i = -1;
					while {_i=_i+1; _i<20} do {
						_action_id = lbValue [(1001+_i*10), lbCurSel (1001+_i*10)];
					
						if (_action_id > 0) then {
							_new_array = [_i+1, _action_id];
							
							// Modifier
							if (_action_id in [1,3,4,5]) then {
								_new_array set [2, call compile (ctrlText (1002+_i*10))];
							};
							
							// List of values
							if (_action_id in [1,3]) then {
								_array = toArray (ctrlText (1003+_i*10));
								
								// remove leading/trailing commas
								while {(_array select 0) == 44} do {_array set [0, objNull]; _array=_array-[objNull]};
								while {(_array select (count _array-1)) == 44} do {_array set [count _array-1, objNull]; _array=_array-[objNull]};
								
								// add brackets
								if ((_array select 0) != 91) then {_array = [91] + _array};
								if ((_array select (count _array-1)) != 93) then {_array set [count _array, 93]};
								
								_new_array set [3, call compile (toString _array)];
							};
							
							_controls set [count _controls, _new_array];
						}
					}
				};
				
				// Enable limiter from the text input
				if (FGS_VEH_SPEED_LIMITER_DIALOG == 3) then {
					_new_max_speed = parseNumber (ctrlText 502);
				};
				
				// Disable limiter
				if (FGS_VEH_SPEED_LIMITER_DIALOG == 4) then {
					_new_max_speed = 0;
				};
				
				// Save and close menu
				if (FGS_VEH_SPEED_LIMITER_DIALOG >= 2) then {
					_config = [_version, _controls, (if (ctrlText 502 == "") then {ctrlText 503} else {ctrlText 502})];
					profileNamespace setVariable ["fgs_veh_speed_limiter", _config];
					FGS_VEH_SPEED_LIMITER_DIALOG = 0;
					closeDialog 0;
				}
			};
			
			// Detect key action
			{
				_key    = Format ["User%1",_x select 0];
				_action = _x select 1;
				
				if ((inputAction (profileNamespace getVariable ["ESE_main_var_userAction", _key]) > 0)) then {
					switch (_action) do {
						// Select limit from a predefined list
						case 1;
						case 3 : {
							if (!(_key in _pressed)) then {
								_pressed set [count _pressed, _key];
								
								_rate       = _x select 2;
								_cycle_list = _x select 3;
								if (!(0 in _cycle_list)) then {_cycle_list set [count _cycle_list,0]};
								_index      = _cycle_list find (if (_action==1) then {_cycle_select} else {_max_speed});
								_final_pick = 0;
								
								if (_index >= 0) then {
									// Move up or down in the speed list
									_index = _index + _rate;
									
									while {_index<0 || _index>=count _cycle_list} do {
										if (_index < 0) then {
											_index = count _cycle_list + _index;
										};
										
										if (_index >= count _cycle_list) then {
											_index = _index - count _cycle_list;
										};
									};
									
									_final_pick = _cycle_list select _index;
								} else {
									// Set to the closest number in the list
									_distance = _cycle_list apply {[abs (_max_speed - _x), _x]};
									_distance sort true;
									_final_pick = (_distance select 0) select 1;
									
									if (
										count _distance > 1 && 
										(_rate > 0 && _final_pick < _max_speed) ||
										(_rate < 0 && _final_pick > _max_speed)
									) then {
										_final_pick = (_distance select 1) select 1;
									};
								};
								
								if (_action == 1) then {
									_cycle_select = _final_pick;
									
									if (_cycle_select > 0) then {
										[_hud_text, Format ["Limit to %1 km/h?", _cycle_select], [194/255, 178/255, 128/255, 0.5]] call _fgs_veh_speed_limiter_set_text;
									} else {
										[_hud_text, "Disable limit?", [194/255, 178/255, 128/255, 0.5]] call _fgs_veh_speed_limiter_set_text;
									}
								} else {
									_new_max_speed = _final_pick;
								}
							}
						};
						
						// Add or subtract from the current limit
						case 4 : {
							_rate = _x select 2;
							
							if (_new_max_speed <= 0) then {
								if (_rate > 0) then {
									_multiple      = (speed vehicle player) / _rate;
									_multiple      = _multiple - _multiple mod 1;
									_new_max_speed = _rate * _multiple + 20;
								} else {
									_new_max_speed = 0
								}
							} else {
								_new_max_speed = _new_max_speed + _rate;
							};
						};
						
						// Set limit to a predefined number
						case 5 : {
							_rate          = _x select 2;
							_new_max_speed = _rate;
						};
						
						// Accept currently selected number from a predefined list
						case 2 : {
							_new_max_speed = _cycle_select;
							
							if (_new_max_speed == 0) then {
								[_hud_text, "", [0,0,0,0]] call _fgs_veh_speed_limiter_set_text;
							};
						};
						
						// Open menu
						case 6 : {
							FGS_VEH_SPEED_LIMITER_DIALOG = 1;
						};
					};
				} else {
					_pressed = _pressed - [_key];
				}
			} forEach _controls;
			
			
			// Show updated limit value
			if (_new_max_speed != _max_speed) then {
				_max_speed = _new_max_speed;
				
				if (_max_speed > 0) then {
					[_hud_text, Format ["Max speed: %1 km/h", floor _max_speed], [0, 0.423, 0.662, 0.5]] call _fgs_veh_speed_limiter_set_text;
				} else {
					[_hud_text, "", [0,0,0,0]] call _fgs_veh_speed_limiter_set_text;
				}
			};
			
			
			// Adjust velocity
			if (_v == _last_vehicle) then {
				if (_max_speed>0  &&  speed _v>_max_speed) then {
					_factor = _factor + 0.005;
					_vel    = velocity _v;
					
					_v setVelocity [
						(_vel select 0) - (_vel select 0) * _factor,
						(_vel select 1) - (_vel select 1) * _factor,
						_vel select 2
					];
				} else {
					_factor = _factor - 0.005;
					if (_factor<0) then {_factor=0};
				}
			} else {
				_last_vehicle = _v;
				_max_speed    = 0;
			}
		} else {
			if (ctrlShown _hud_text) then {
				_hud_text ctrlShow false;
			}
		};
		
		sleep 0.1;
	}
};
}